# atoi, atol, atoll

From cppreference.com
< c‎ | string‎ | byte

Defined in header `<stdlib.h>` |  |
int atoi( const char *str ); |  |
long atol( const char *str ); |  |
long long atoll( const char *str ); |  | (since C99)

Interprets an integer value in a byte string pointed to by `str`.

Discards any whitespace characters until the first non-whitespace character is found, then takes as many characters as possible to form a valid integer number representation and converts them to an integer value. The valid integer value consists of the following parts:

- (optional) plus or minus sign
- numeric digits

### Parameters

str | - | pointer to the null-terminated byte string to be interpreted

### Return value

Integer value corresponding to the contents of `str` on success. If the converted value falls out of range of corresponding return type, the return value is undefined. If no conversion can be performed, ​0​ is returned.

### Example

Run this code

    #include <stdio.h>
    #include <stdlib.h>

    int main(void)
    {
        printf("%i\n", atoi(" -123junk"));
        printf("%i\n", atoi("0"));
        printf("%i\n", atoi("junk"));         // no conversion can be performed
        printf("%i\n", atoi("2147483648"));   // UB: out of range of int
    }

Output:

    -123
    0
    0
    -2147483648

### References

- C11 standard (ISO/IEC 9899:2011):

  - 7.22.1.2 The atoi, atol, and atoll functions (p: 341)

- C99 standard (ISO/IEC 9899:1999):

  - 7.20.1.2 The atoi, atol, and atoll functions (p: 307)

- C89/C90 standard (ISO/IEC 9899:1990):

  - 4.10.1.2 The atoi function

  - 4.10.1.3 The atol function

### See also

strtolstrtoll (C99) | converts a byte string to an integer value (function)
strtoul strtoull (C99) | converts a byte string to an unsigned integer value (function)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=c/string/byte/atoi&oldid=87726"